<?php

	/**
	 * Kundengruppemodell
	 * @author Daschmi
	 */
	class wpsg_customergroup extends wpsg_model
	{
		
		/**
		 * Lädt die Daten der Kundengruppe
		 */
		public function load($customer_group_id)
		{
			
			parent::load($customer_group_id);
			
			$this->data = $this->db->fetchRow("
				SELECT 
					KG.*,
					(SELECT COUNT(*) FROM `".WPSG_TBL_KU."` AS K WHERE K.`group_id` = KG.`id`) AS `customercount` 
				FROM
					`".WPSG_TBL_KG."` AS KG
				WHERE
					KG.`id` = '".wpsg_q($customer_group_id)."'
			");
				
			if ($this->data['id'] != $customer_group_id || !wpsg_isSizedInt($customer_group_id)) return false;
			
			return true;
			
		} // public function __construct($customer_group_id)
		
		/**
		 * Löscht eine Kundengruppe
		 */
		public static function delete($customer_group_id)
		{
			
			if (!wpsg_isSizedInt($customer_group_id)) return false;
			
			// Kundengruppe löschen
			$GLOBALS['wpsg_db']->Query("DELETE FROM `".WPSG_TBL_KG."` WHERE `id` = '".wpsg_q($customer_group_id)."' ");
			
			// Kundengruppen ID in den Kunden auf Null setzen
			$GLOBALS['wpsg_db']->UpdateQuery(WPSG_TBL_KU, array(
				'group_id' => 'NULL'
			), " `group_id` = '".wpsg_q($customer_group_id)."' ");
			
			return true;
			
		} // public static function delete($customer_group_id)
 
		public static function count($arFilter = array())
		{

			list($strQuerySELECT, $strQueryWHERE, $strQueryJOIN, $strQueryHAVING, $strQueryORDER) = self::getQueryParts($arFilter);

			$strQuery = "
				SELECT
					COUNT(*)
				FROM
					(
						SELECT
						  	DISTINCT CG.`id`
						FROM
							`".WPSG_TBL_KG."` AS CG
							".$strQueryJOIN."
						WHERE
							1
							".$strQueryWHERE." 
						HAVING
							1
							".$strQueryHAVING."											
					) AS innerSelect
			";

			return $GLOBALS['wpsg_db']->fetchOne($strQuery);

		} // public static function count($arFilter = array())

		/**
		 * Gibt einen Array von Kundengruppen zurück, die auf den übergebenen Filter passen
		 * @param array $arFilter
		 */
		public static function find($arFilter = array())
		{

			list($strQuerySELECT, $strQueryWHERE, $strQueryJOIN, $strQueryHAVING, $strQueryORDER) = self::getQueryParts($arFilter);

			$strLimit = "";

			if (wpsg_isSizedArray($arFilter['limit'])) $strLimit = "LIMIT ".wpsg_q($arFilter['limit'][0]).", ".wpsg_q($arFilter['limit'][1]);

			$strQuery = "
				SELECT
					CG.`id`
					".$strQuerySELECT."
				FROM
					`".WPSG_TBL_KG."` AS CG
						".$strQueryJOIN."
				WHERE
					1
					".$strQueryWHERE."
				HAVING
					1
					".$strQueryHAVING."
				ORDER BY
					".$strQueryORDER."		
				".$strLimit."
			";

			$arCustomerID = $GLOBALS['wpsg_db']->fetchAssocField($strQuery);
			$arReturn = array();

			foreach ($arCustomerID as $customer_id)
			{

				$arReturn[$customer_id] = self::getInstance($customer_id);

			}

			return $arReturn;


		} // public static function find($arFilter = array())

		public static function getQueryParts($arFilter = array())
		{

			$strQuerySELECT = "";
			$strQueryWHERE = "";
			$strQueryJOIN = "";
			$strQueryHAVING = "";
			$strQueryORDER = "";

			$strQuerySELECT .= "
				,(SELECT COUNT(*) FROM `".WPSG_TBL_KU."` AS K WHERE K.`group_id` = CG.`id`) AS `customercount`
			";

			if (wpsg_isSizedString($arFilter['s'])) $strQueryWHERE .= " AND CG.`name` LIKE '%".wpsg_q($arFilter['s'])."%' ";

			if (wpsg_isSizedString($arFilter['name'])) $strQueryWHERE .= " AND CG.`name` LIKE '%".wpsg_q($arFilter['name'])."%' ";

			if (wpsg_isSizedString($arFilter['order'], 'name')) { $strQueryORDER = " CG.`name` "; }
			else if (wpsg_isSizedString($arFilter['order'], 'customercount')) { $strQueryORDER = " `customercount` "; }
			else if (wpsg_isSizedString($arFilter['order'], 'calculation')) { $strQueryORDER = " CG.`calculation` "; }
			else $strQueryORDER = " CG.`id` ";

			// Richtung
			if (wpsg_isSizedString($arFilter['ascdesc'], "DESC")) $strQueryORDER .= " DESC ";
			else $strQueryORDER .= " ASC ";

			return array($strQuerySELECT, $strQueryWHERE, $strQueryJOIN, $strQueryHAVING, $strQueryORDER);

		}

	} // class wpsg_customergroup

?>